/*
 *  ofxiPhoneVideoPlayer.h
 *  ffmpeg
 *
 *  Created by theo on 13/12/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#pragma once

#include "ofMain.h"

#define __STDC_CONSTANT_MACROS

#ifdef __cplusplus
extern "C" {
#endif

#include "libavcodec/avcodec.h"
#include "libavformat/avformat.h"
#include "libswscale/swscale.h"

#ifdef __cplusplus
}
#endif

#ifndef OF_LOOP_NORMAL

#define OF_LOOP_NONE					0x01
#define OF_LOOP_PALINDROME				0x02
#define OF_LOOP_NORMAL					0x03

#endif

class ofxiPhoneVideoPlayer : public ofBaseDraws, public ofBaseHasPixels, public ofBaseUpdates, public ofBaseHasTexture{
	
	public:
		ofxiPhoneVideoPlayer(void);
		virtual ~ofxiPhoneVideoPlayer(void);
	
		bool 				loadMovie(string name);
		void 				closeMovie(){}
		void 				close(){}

		void				update();			//same as idleMovie
		void 				idleMovie(){}		// rename to updateMovie?
		void 				play();
		void 				stop();

		int 				width, height;
		float  				speed;
		bool 				bLoaded;

		bool 				isFrameNew(){return true; }
		unsigned char * 	getPixels();
		float 				getPosition(){ return 0.0; }
		float 				getSpeed(){ return 1.0; }
		float 				getDuration(){ return 1.0; }
		bool				getIsMovieDone(){ return false; }

		void 				setPosition(float pct){}
		void 				setVolume(int volume){}
		void 				setLoopState(int state){ if(state == OF_LOOP_NORMAL) bLoop = true; else bLoop = false; }
		void   				setSpeed(float speed){}
		void				setFrame(int frame){}  // frame 0 = first frame...

		void 				setUseTexture(bool bUse){}
		ofTexture &			getTextureReference(){ return tex; }
		void 				draw(float x, float y, float w, float h);
		void 				draw(float x, float y);

		//the anchor is the point the image is drawn around.
		//this can be useful if you want to rotate an image around a particular point.
        void				setAnchorPercent(float xPct, float yPct){ tex.setAnchorPercent(xPct, yPct); }	//set the anchor as a percentage of the image width/height ( 0.0-1.0 range )
        void				setAnchorPoint(int x, int y){tex.setAnchorPoint(x, y);}				//set the anchor point in pixels
        void				resetAnchor(){tex.resetAnchor();}								//resets the anchor to (0, 0)

		void 				setPaused(bool bPause);

		int					getCurrentFrame(){return 0;}
		int					getTotalNumFrames(){return 0;}

		void				firstFrame(){}
		void				nextFrame(){}
		void				previousFrame(){}

		float 				getHeight(){ return width; }
		float 				getWidth(){ return height; }
	
	//from ofVideoPlayer
	public: 
		int					nFrames;				// number of frames
		unsigned char * 	pixels;					// 24 bit: rgb
		bool 				bHavePixelsChanged;
		ofTexture 			tex;					// a ptr to the texture we are utilizing
		bool 				bUseTexture;			// are we using a texture
		bool				allocated;				// so we know to free pixels or not
		bool				bPlaying;

	private:
		bool OpenAVI(string filename);
		void GrabAVIFrame();
		int Update(DWORD milliseconds);
		
		int					millisLastFrame;

		uint8_t 			*data;
		int					nwidth;
		int					nheight;
		DWORD dwNext;
		double dNext;
		double dDur;
		DWORD dwDur;
		DWORD dwFrame;
		DWORD dwFrameSys;
		void SetZeroCount(void);
		void CloseAVI(void);
		bool bLoad;
		bool bLoop;
		bool bResize;
		bool bActive;
		void SetResize(void);
		void ClearResize(void);

	//private:
		string chFile;
		int CreateContext();
		void DestroyContext();
		AVFormatContext *pFormatCtx;
		int             videoStream;
		AVCodecContext  *pCodecCtx;
		AVCodec         *pCodec;
		AVFrame         *pFrame; 
		AVFrame         *pFrameRGB;
		AVPacket        packet;
		AVStream* video_st;
		struct SwsContext *img_convert_ctx;
		int             frameFinished;
		int             numBytes;
		uint8_t         *buffer;
		double dTimeBase;
		double dPts;
};


